;****************************************************
;phasecut-unit
;****************************************************


;0x61 = phasecut-sollwert	
;0x62 =	phasecut-sollwert backup	;...
;
;0x63 = phasecut-maximalwert			
;0x64 = phasecut-maximalwert backup
	
;0x65 = phasecut-istwert
;0x67 = phasecut-istwert backup

;0x7b = led-flags
;
;flags
;.equ	led_on		=	0
;.equ	led_pulse	=	1
;.equ	led_short	=	2
;.equ	led_long	=	3
;.equ	led_off		=	4

;
phasecut_unit:

	;
	;aktivity-flag holen..
	lds		r17,0x73
	sbrs	r17,aktiv
	rjmp	_unitBK
	;	
	;zuerst PWR_out = HIGH (aus)
	sbi	portb,PWR_out
	;
	;indikator
	sbi	portb,indi_55mic
	;
	;sofort evtl.zero-flag pr.
	lds	r19,0x60
	sbrs	r19,zeroX
	rjmp	_phaseRUN
	cbr	r19,1<<zeroX
	;phaseOK clr
	cbr	r19,1<<phaseOK
	sts	0x60,r19
	;ja zero-event !
	;phasecut-istwert = 0
	clr	yl
	sts	0x65,yl

	;
_phaseRUN:
	;hole phasecut-sollwert...
	;soll/istvergleich
	;pwr_out schon aktiv (L) ?
	lds	yl,0x61
	rcall	_CONVsub
	lds	r17,0x65	;istwert...
	cp	r17,yl	;ist >=soll dann ein fr 55,3s !! (mal schaun ob's reicht ?)
	brsh _PHunitON	
	rjmp	_PHunitBACK	
	;ein...
_PHunitON:

	;phaseOK-flag prfen...
	lds	r19,0x60
	sbrc	r19,phaseOK
	rjmp	_PHunitBACK
	sbr	r19,1<<phaseOK
	sts	0x60,r19
	;
	cbi		portb,PWR_out
_PHunitBACK:
	inc	r17	;istwert +1 (+55,3s)
	sts	0x65,r17
	;indikator
	cbi	portb,indi_55mic
	;
_unitBK:
	ret


;------------------------------------------


_CONVsub:
clr		yh
subi		yl,low(-_CONVtrig*2)
sbci		yh,high(-_CONVtrig*2)
lpm 
;korrigierter phasecut-wert
mov		yl,r0
ret







;neue tabelle II
;Fehler== mittlerer bis maximaler bereich nicht linear...
;- minimale helligkeit = 157
;- maximale "       "  = 25
.cseg

_CONVtrig:
.db	157,156,155,154,153,152,151,150
.db	150,149,149,148,148,147,147,146
.db	146,145,145,144,144,143,143,142
.db	142,141,141,140,140,139,139,138



.db	138,137,137,136,136,135,135,134
.db	134,133,133,132,132,131,131,130	
.db	130,129,129,128,128,127,127,126	
.db	126,125,125,124,124,123,123,122




.db	122,121,121,120,120,119,119,118
.db	118,117,117,116,116,115,115,114
.db	114,113,113,112,112,111,111,110




.db	110,109,109,108,108,107,107,106
.db	106,105,105,104,104,103,103,102
.db	102,101,101,100,99,98,97,96
.db	95,94,93,92,91,90,89,88
.db	87,86,85,84,83,82,81,80
.db	79,78,77,76,75,74,73,72
.db	71,70,69,68,67,66,65,64
.db	63,62,61,60,59,58,57,56
.db	55,54,53,52,51,50,49,48
.db	47,46,45,44,43,42,41,40
.db	39,38,37,36,35,34,33,32
.db	31,30,29,28,27,26,25,25

.exit


